#include <string.h>
#include <stdio.h>
#include <math.h>
#include <XRS/string_format.h>

//***************** string format function ***********************

void string(char *p,char* s,int n)
{
    int i,j,k;
    char *ss=new char [n+1];

    i=(int)strlen(s);
    if( i > n ) i=n;
    k=(int)((n-i)/2);
    for( j=0; j<k; j++ ) ss[j]=' ';
    ss[k]='\0';
    strncat(ss,s,i);
    for(j=k+i; j<n; j++) ss[j]=' ';
    ss[n]='\0';
    
    strcpy(p,ss);
    delete [] ss; ss=NULL;
}


int parameter_string(char *s,char *ds,double p,double dp,char *format)
{
   int k,n,i,digit;
   char *dot;

   digit=(int)floor(log10(dp)+0.5);
   if(digit>=0) digit++;

   sprintf(s,format,p); i=(int)strlen(s);
   for(k=0; k<i; k++) ds[k]=' ';
   ds[i]='\0';

   if( (dot=strrchr(s,'.'))==NULL ) dot=strrchr(s,'\0');
   n=(int)(dot-digit-s);
   if( n >=0 && n < i) ds[n]=*(dot-digit);
   return i;
}


int parameter_string(char *s,char *ds,int p,int dp,char *format)
{
   int k,n,i,digit;
   char *dot;

   digit=(int)floor(log10(dp)+0.5)+2;
   sprintf(s,format,p); i=(int)strlen(s);
   for(k=0; k<i; k++) ds[k]=' ';
   ds[i]='\0';

   dot=strrchr(s,'\0');
   n=(int)(dot-digit-s);
   if( n >=0 && n < i) ds[n]=*(dot-digit);
   return i;
}


void copy_string(char *&s,const char *s1,const char *s2,const char *s3){
   if(s!=NULL){ delete [] s; s=NULL;}
   int len=(int)strlen(s1)+1;
   if(s2!=NULL){ len+=(int)strlen(s2); if(s3!=NULL) len+=(int)strlen(s3);}
   s=new char [len+1];
  
   strcpy(s,s1);
   if(s2!=NULL){ strcat(s,s2); if(s3!=NULL) strcat(s,s3);}
}

