#ifndef XRS_COLOR_MANIPULATER_H
#define XRS_COLOR_MANIPULATER_H

#ifndef NULL	
#define NULL 0
#endif
	
//======== COLOR(const char*) ===============================
struct COLOR_Pc{ 
    char*  x;
    COLOR_Pc(const char *y){ x=(char*) y; }
};

COLOR_Pc COLOR(const char* c=NULL){  return COLOR_Pc(c); }


//======== MONO(double,int) ===========================
struct MONO_di{  
    double x;
    int    n;
    MONO_di(double y,int m){ x=y; n=m;}
};

MONO_di MONO(double x=-1,int n=0){ return MONO_di(x,n); } 

//======== PHASE(double,int) ==========================
struct PHASE_di{  
    double x;
    int    n;
    PHASE_di(double y,int m){ x=y; n=m;}
};

PHASE_di PHASE(double x=-1,int n=0){ return PHASE_di(x,n); } 

//======== COLOR(unsigned long [],int) ========================
struct COLOR_A_Uli{ 
    unsigned long *x;
    int   n;
    COLOR_A_Uli(unsigned long y[],int m){ x=y;  n=m;}
};

COLOR_A_Uli COLOR(unsigned long c[],int n){ return COLOR_A_Uli(c,n);}

#endif

